using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace UUN
{
    /// <summary>
    /// 动态文件的会员列表编译部分
    /// </summary>
    public class 编译扩展_动态文件_会员列表 : 编译扩展接口
    {
        private SqlConnection 连接;
        private HttpContext HC;
        private 编译器 编译器;

        public 编译扩展_动态文件_会员列表(SqlConnection 连接, HttpContext HC, 编译器 编译器)
        {
            this.连接 = 连接;
            this.HC = HC;
            this.编译器 = 编译器;
        }

        private int 动态文件_会员列表_一页显示记录数 = 0;

        public String 开始执行代码()
        {
            编译器.方法库 += @"	private String 当前页面=@"""+编译器.文件名称.Replace("\"","\"\"")+ @""";
	//参数
	private String 用户组;
	private int 是否在线;
	private int 排序;
	//其它
	private String 跳页表单项;
	private String _3G跳页表单项;
	private String 查询条件="""";
	//列表分页
	private int 当前页;
	private int 总页数;
	private int 总记录数;
	private int 一页显示记录数;
	private String 列表跳页(int 页码)
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?usergroups=""+
			Server.UrlEncode(用户组)+
			""&online=""+是否在线+
			""&order=""+排序+
			""&page=""+页码,访问.用户[""标识""].ToString()));
	}
	private String 生成余下全部地址()
	{
		return """";
	}
";
            String 返回值 = "";
            返回值 += @"	用户组=Request.QueryString[""usergroups""];
	是否在线=Convert.ToInt32(Request.QueryString[""online""]);
	排序=Convert.ToInt32(Request.QueryString[""order""]);
	一页显示记录数=获取一页显示记录数();
	跳页表单项=""<postfield name=\""usergroups\"" value=\""""+
		Server.HtmlEncode(用户组)+
		""\"" />""+
		""<postfield name=\""online\"" value=\""""+
		是否在线+
		""\"" />""+
		""<postfield name=\""order\"" value=\""""+
		排序+
		""\"" />""+
		""<postfield name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+
		访问.用户[""标识""]+
		""\"" />"";
	_3G跳页表单项=""<input type=\""hidden\"" name=\""usergroups\"" value=\""""+
		Server.HtmlEncode(用户组)+
		""\"" />""+
		""<input type=\""hidden\"" name=\""online\"" value=\""""+
		是否在线+
		""\"" />""+
		""<input type=\""hidden\"" name=\""order\"" value=\""""+
		排序+
		""\"" />""+
		""<input type=\""hidden\"" name=\""""+程序.设置[""标识名称""]+""\"" value=\""""+
		访问.用户[""标识""]+
		""\"" />"";
";
            返回值 += 生成会员列表条件(true, "");
            返回值 += "\t\t当前页=Convert.ToInt32(Request.QueryString[\"page\"]);\r\n";
            返回值 += "\t\t总记录数=Convert.ToInt32(数量语句.ExecuteScalar());\r\n";
            返回值 += "\t\t总页数=常用.计算总页数(总记录数,一页显示记录数);\r\n";
            返回值 += "\t\t当前页=常用.计算当前页(总页数,当前页);\r\n";

            return 返回值;
        }

        public String 编译公共标签(String 代码)
        {
            switch (代码)
            {
                case "当前页":
                    return "\t\t返回值.Append(当前页.ToString());\r\n";
                case "总页数":
                    return "\t\t返回值.Append(总页数.ToString());\r\n";
                case "总记录数":
                    return "\t\t返回值.Append(总记录数.ToString());\r\n";
                default:
                    return "";
            }
        }

        public String 编译模板方法(String 方法名称, String[] 属性数组)
        {
            switch (方法名称)
            {
                case "_会员列表":
                    return 编译模板方法_动态文件_会员列表(属性数组[0],
                        属性数组[1],
                        属性数组[2],
                        属性数组[3]);
                case "列表分页":
                    return 编译模板方法_动态文件_列表分页(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "分页设置":
                    return 编译模板方法_动态文件_分页设置(Convert.ToInt32(属性数组[0]));
                default:
                    return "";
            }
        }

        private String 编译模板方法_动态文件_会员列表(String 空记录代码, String 格式, String 交替格式, String 时间格式)
        {
            String 随机值 = 常用.随机字符(8);

            Hashtable 必须字段 = new Hashtable();
            必须字段.Add("序号", "");
            必须字段.Add("会员资料地址", "ID");
            Hashtable 字段代码 = new Hashtable();
            字段代码.Add("序号", "(当前页-1)*一页显示记录数+i+1");
            字段代码.Add("昵称", @"Server.HtmlEncode(行[""昵称""].ToString())");
            字段代码.Add("手机号", @"Convert.ToInt64(行[""手机号""])==0?"""":Convert.ToString(行[""手机号""]).Substring(0,7)+""****""");
            字段代码.Add("性别", @"Convert.ToBoolean(行[""性别""])?程序.设置[""单位名词_男性名词""].ToString():程序.设置[""单位名词_女性名词""].ToString()");
            字段代码.Add("个人签名", "Convert.IsDBNull(行[\"个人签名\"])?\"\":常用.UBB转换(Server.HtmlEncode(行[\"个人签名\"].ToString()),访问.用户[\"标识\"].ToString())");
            字段代码.Add("会员资料地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"User.aspx?ID=""+行[""ID""]+""&Rurl=""+Server.UrlEncode(Request.Url.ToString()),访问.用户[""标识""].ToString()))");
            字段代码.Add("最后访问时间", @"Convert.ToDateTime(行[""最后访问时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("最后登录时间", @"Convert.ToDateTime(行[""最后登录时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("最后登录IP", @"Convert.ToString(行[""最后登录IP""])==""""?"""":行[""最后登录IP""].ToString().Substring(0,行[""最后登录IP""].ToString().Length-4)+""****""");
            字段代码.Add("所在位置", @"Server.HtmlEncode(行[""所在位置""].ToString())");
            字段代码.Add("创建时间", @"Convert.ToDateTime(行[""创建时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("头像", @"Convert.ToString(行[""头像""])==""""?"""":""<img src=\""""+行[""头像""]+""\"" alt=\""头像\""""+常用.获取头像宽度高度()+"" />""");
            字段代码.Add("勋章", @"常用.显示所有图片(行[""勋章""].ToString())");

            String 查询字段, 行代码;
            查询字段 = 编译器.生成查询字段(格式, 交替格式, 必须字段, 字段代码, out 行代码);

            编译器.方法库 += "\tprivate void 会员列表" + 随机值 + "()\r\n";
            编译器.方法库 += "\t{\r\n";
            编译器.方法库 += "\t\tif(总记录数<1)\r\n";
            编译器.方法库 += "\t\t\t返回值.Append(@\"" + 空记录代码.Replace("\"", "\"\"") + "\");\r\n";
            编译器.方法库 += 生成会员列表条件(false, 查询字段);
            编译器.方法库 += 生成查询结果列表(行代码);

            return "\t\t会员列表" + 随机值 + "();\r\n";
        }
        private String 生成查询结果列表(String 行代码)
        {
            String 返回值 = "";
            返回值 += "\t\tDataSet 数据=new DataSet();\r\n";
            返回值 += "\t\tSqlDataAdapter 填充=new SqlDataAdapter(语句);\r\n";
            返回值 += "\t\t填充.Fill(数据,(当前页-1)*一页显示记录数,一页显示记录数,\"表\");\r\n";
            返回值 += "\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += 行代码;
            返回值 += "\t\t}\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_动态文件_列表分页(int ID, String 无分页代码)
        {
            return 编译器.编译内容分页(
                (编译器.文件名称.StartsWith(程序.安装位置 + "club/", StringComparison.OrdinalIgnoreCase) ? "Club" : "Content"),
                "Page", ID, 无分页代码);
        }

        private String 编译模板方法_动态文件_分页设置(int 一页显示记录数)
        {
            if (一页显示记录数 > 0)
                动态文件_会员列表_一页显示记录数 = 一页显示记录数;
            return "";
        }

        public String 结束执行代码()
        {
            编译器.方法库 += @"	private int 获取一页显示记录数()
	{
";
            if (动态文件_会员列表_一页显示记录数 == 0)
                编译器.方法库 += "\t\treturn 访问.获取一页显示记录数();\r\n";
            else
                编译器.方法库 += "\t\treturn " + 动态文件_会员列表_一页显示记录数 + ";\r\n";
            编译器.方法库 += @"
	}
";
            return "";
        }

        private String 生成会员列表条件(bool 是否数量, String 查询字段)
        {
            String 返回值 = "";
            String 语句名称 = 是否数量 ? "数量语句" : "语句";
            返回值 += @"
		DateTime? 查询参数=null;
";
            if (是否数量)
            {
                返回值 += @"		查询条件=@"" WHERE [用户类型]='会员'"";

		if(用户组!=""""&&用户组!=null)
		{
			String[] 用户组数组=用户组.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);
			String 用户组查询=""("";
			for(int i=0;i<用户组数组.Length;i++)
				用户组查询+=(i==0?"""":"" OR "")+""[用户组]='""+常用.SQL_过滤注入(用户组数组[i])+""'"";
			用户组查询+="")"";
			查询条件+="" AND ""+用户组查询;
		}
		if(是否在线==1)
		{
			查询条件+="" AND "";
			查询条件+=""[最后访问时间]>@最后访问时间"";
			查询参数=DateTime.Now-new TimeSpan(0,Convert.ToInt32(程序.设置[""离线时间""]),0);
		}
";
            }
            返回值 += "\t\tString " + 语句名称 + "SQL=\"SELECT " + (是否数量 ? "COUNT(ID)" : 查询字段) + " FROM [\"+程序.数据表前缀+\"社区_用户_用户]\"+查询条件;\r\n";
            if (!是否数量)
            {
                返回值 += "\t\t" + 语句名称 + "SQL+=\" ORDER BY \";\r\n";
                返回值 += @"		switch(排序)
		{
			case 0:
				"+语句名称+ @"SQL+=""[ID] DESC"";
				break;
			case 1:
				"+语句名称+ @"SQL+=""[积分] DESC"";
				break;
			case 2:
				"+语句名称+ @"SQL+=""[最后访问时间] DESC"";
				break;
			case 3:
				"+语句名称+ @"SQL+=""[最后登录时间] DESC"";
				break;
			case 4:
				"+语句名称+ @"SQL+=""[等级] DESC"";
				break;
			case 5:
				"+语句名称+@"SQL+=""[今日访问次数] DESC"";
				break;
		}
";
            }
            返回值 += "\t\tSqlCommand " + 语句名称 + "=new SqlCommand(" + 语句名称 + "SQL,访问.连接);\r\n";
            返回值 += "\t\tif(查询参数!=null)\r\n";
            返回值 += "\t\t\t" + 语句名称 + ".Parameters.Add(\"@最后访问时间\",SqlDbType.DateTime).Value=查询参数;\r\n";
            return 返回值;
        }
    }
}